#ifndef HEPMC3EVENT_H
#define HEPMC3EVENT_H

#include <memory>
#include <string>

#include "HepMC3/GenParticle.h"
#include "HepMC3/Print.h"
#include "HepMC3/GenEvent.h"
#include "HepMC3/GenVertex.h"
#include "HepMC3/Writer.h"

using namespace HepMC3;



class HEPMC3event
{
 public:

  HEPMC3event();
  HEPMC3event(std::string filename);

  // Public methods
  void Initialise();
  void InitEvent();
  void Write();
  void Close();
  void AddParticleIn(int barcode, double px, double py, double pz, double e, int status);
  void AddParticleOut(int barcode, double px, double py, double pz, double e, int status);
  void SetWeight(double weight);
  void SetPosition(double x, double y, double z);

  void Attribute_impact(double value);
  void Attribute_eventtype(int value);

 private:
  std::string m_filename;
  GenEvent evt;
  GenVertexPtr v1;
  std::shared_ptr<Writer> writer;
};


#endif // HEPMC3EVENT_H
